{-------------------------------}
{            GOOIEN             }
{                               }
{Een dobbelspel in Turbo Pascal }
{                               }
{    door Jeff Duntemann        }
{                               }
{ Laatste verandering: 12/4/84  }
{-------------------------------}

PROGRAM GOOIEN;

CONST STEEN_KANTEN : ARRAY[0..5,0..2] OF STRING[5] =
                   (('     ','  o  ','     '),  { 1 }
                    ('o    ','     ','    o'),  { 2 }
                    ('    o','  o  ','o    '),  { 3 }
                    ('o   o','     ','o   o'),  { 4 }
                    ('o   o','  o  ','o   o'),  { 5 }
                    ('o o o','     ','o o o')); { 6 }

TYPE GRAFREC = RECORD        { Om vakken te tekenen }
                 LB_HOEK,
                 RB_HOEK,
                 LO_HOEK,
                 RO_HOEK,
                 H_BALK,
                 V_BALK,
                 KRUISING,
                 T_OMLAAG,
                 T_OMHOOG,
                 T_RECHTS,
                 T_LINKS     : STRING[4]
               END;
     STRING80  = STRING[80];


VAR GRAFKARS  : GRAFREC;
    TOSS      : INTEGER;
    OPSCHRIFT : STRING80;
    STENEN    : INTEGER;
    STENEN_X  : INTEGER;
    I         : INTEGER;
    CH        : CHAR;
    STOP      : BOOLEAN;

{$I GRAFKARS.MSX }


PROCEDURE MAAK_VAK(X,Y,BREEDTE,HOOGTE : INTEGER;
                      GRAFKARS        : GRAFREC);

VAR I,J : INTEGER;

BEGIN
  IF X < 0 THEN X := (80-BREEDTE) DIV 2;    { Negatieve X centreert vak}
  WITH GRAFKARS DO
    BEGIN                                   { Teken bovenste lijn }
      GOTOXY(X,Y); WRITE(LB_HOEK);
      FOR I := 3 TO BREEDTE DO WRITE(H_BALK);
      WRITE(RB_HOEK);
                                            { Teken onderste lijn }
      GOTOXY(X,(Y+HOOGTE)-1); WRITE(LO_HOEK);
      FOR I := 3 TO BREEDTE DO WRITE(H_BALK);
      WRITE(RO_HOEK);
                                            { Teken zijlijnen }
      FOR I := 1 TO HOOGTE-2 DO
        BEGIN
          GOTOXY(X,Y+I); WRITE(V_BALK);
          GOTOXY((X+BREEDTE)-1,Y+I); WRITE(V_BALK)
        END
    END
END;


PROCEDURE GOOI(X,Y            : INTEGER;
               AANTAL_STENEN : INTEGER;
               VAR TOSS       : INTEGER);

VAR I,J,WORP,X_OFFSET : INTEGER;

BEGIN
  IF (AANTAL_STENEN * 9)+X >= 80 THEN      { Te veel stenen horizontaal    }
    AANTAL_STENEN := (80-X) DIV 9;         { gooien scherm overhoop!       }
  FOR I := 1 TO AANTAL_STENEN DO
    BEGIN
      X_OFFSET := (I-1)*9;      { Offset van negen spaties voor elke steen }
      MAAK_VAK(X+X_OFFSET,Y,7,5,GRAFKARS); { Teken een steen }
      WORP := RANDOM(6);                    { "Gooi" hem  }
      FOR J := 0 TO 2 DO                    { en teken de punten }
        BEGIN
          GOTOXY(X+1+X_OFFSET,Y+1+J);
          WRITE(STEEN_KANTEN[WORP,J])
        END
    END
 END;



BEGIN
  RANDOMIZE;                   { Initialiseer pseudorandom getallengenerator }
  CLRSCR;                      { Wis hele scherm }
  STOP := FALSE;               { Initialiseren stopvlag }
  DEFINIEER_KARS(GRAFKARS);    { Karakters om vakken te tekenen ophalen }
  OPSCHRIFT := 'WE GAAN MET STENEN GOOIEN!';
  MAAK_VAK(-1,1,LENGTH(OPSCHRIFT)+4,3,GRAFKARS);    { Teken vak voor opschift }
  GOTOXY((80-LENGTH(OPSCHRIFT)) DIV 2,2); WRITE(OPSCHRIFT);  { Opschrift erin }
  REPEAT
    REPEAT
      FOR I := 6 TO 18 DO                 { Speldeel van scherm wissen }
        BEGIN
          GOTOXY(1,I);
          CLREOL
        END;
      GOTOXY(1,6);
      WRITE('>>Met hoeveel stenen zullen we gooien? (1-5, of 0 om te stoppen): ');
      READLN(STENEN);
      IF STENEN = 0 THEN STOP := TRUE ELSE    { Nul stenen -> stopvlag }
        IF (STENEN < 1) OR (STENEN > 5) THEN  { Foutmelding als aantal niet OK}
          BEGIN
            GOTOXY(1,23);
            WRITE('>>Aantal stenen tussen 1 en 5!')
          END
    UNTIL (STENEN >= 0) AND (STENEN <= 5);
    GOTOXY(1,23); CLREOL;           { Eventuele resten van meldingen wissen}
    IF NOT STOP THEN                { Spelen! }
      BEGIN
        STENEN_X := (80-(9*STENEN)) DIV 2;{ Centrale punt voor stenen berekenen}
        REPEAT
          GOTOXY(1,16); CLREOL;
          GOOI(STENEN_X,9,STENEN,TOSS);             { Stenen gooien en tekenen}
          GOTOXY(1,16); WRITE('>>Opnieuw gooien? (J/N): ');
          READ(KBD,CH);
        UNTIL NOT (CH IN ['J','j']);
        GOTOXY(1,18); WRITE('>>Nog een spelletje ? (J/N): ');
        READ(KBD,CH);
        IF NOT (CH IN ['J','j']) THEN STOP := TRUE
      END
  UNTIL STOP      { Stopvlag bepaalt einde van spel }
END.
