{--------------------------------------------------------------}
{                          HEXDUMP                             }
{                                                              }
{            Hexdump programma voor alle diskfiles             }
{                                                              }
{                             door Jeff Duntemann              }
{                             Turbo Pascal V2.0                }
{                             Laatste verbetering 12/11/84     }
{                                                              }
{                 (c) 1984 by Jeff Duntemann                   }
{                     ALL RIGHTS RESERVED                      }
{--------------------------------------------------------------}

PROGRAM HEXDUMP;

{ Let op de aanpassingen voor de MSX i.v.m. printer; zie bijlage boek. }



{$V-}  { Afzwakken van controle op lengte van strings als VAR-paramaters }

CONST HOOFD   = TRUE;
      KLEIN   = FALSE;

TYPE STRING255   = STRING[255];
     STRING128   = STRING[128];
     STRING80    = STRING[80];
     STRING40    = STRING[40];
     PARM_ARRAY  = ARRAY[1..10] OF STRING40;  { Hier worden parms }
                                   { van opdrachtregel opgeslagen }
     BLOK        = ARRAY[0..127] OF BYTE;   { Een disksector      }
     BLOK_ARRAY  = ARRAY[0..15] OF BLOK;    { BLOCKREAD leest     }
                                            { 16 blokken tegelijk }


VAR I,J,K       : INTEGER;
    PARMS       : PARM_ARRAY;
    CH          : CHAR;
    DUMPFILE    : FILE;
    XBLOK       : BLOK;
    DISKDATA    : BLOK_ARRAY;
    IOCODE      : INTEGER;
    BLOKKEN     : INTEGER;        { Telt blokken in }
                                  { BLOK_ARRAY }
    BLOK_TEL    : INTEGER;        { Turft aantal gelezen blokken }
    BUFFERS     : INTEGER;
    REMAINS     : INTEGER;
    APPARAAT    : TEXT;           { Is of LST: of CON: }


           {<<<<PLAATS VAN STAART VAN OPDRACHTREGEL>>>>}

    {In elke versie van Turbo is slechts een van de volgende   }
    {declararties geldig. Kies degene die bij uw operating     }
    {system hoort door die als enige buiten commentaarhaken te }
    {zetten; de andere moet dus tussen dergelijke hakenstaan!  }

    { RAM_STAART : STRING128 ABSOLUTE CSEG : $80;}   { MS/PC DOS }
      RAM_STAART : STRING128 ABSOLUTE $80;         { CP/M }


{$I DWNGKAST.SRC }   { Bevat DWING_KAST }

{$I WEGWIT.SRC }     { Bevat WEGWIT     }

{$I ONTRSTRT.SRC }   { Bevat ONTRAFEL_STAART }

{$I JA.SRC }         { Bevat JA }


{>>>>SCHRIJF_HEX<<<<}

PROCEDURE SCHRIJF_HEX(VAR APPARAAT : TEXT; BT : BYTE);

CONST HEXCIJFERS : ARRAY[0..15] OF CHAR = '0123456789ABCDEF';

VAR BZ : BYTE;

BEGIN
  BZ := BT AND $0F;
  BT := BT SHR 4;
  WRITE(APPARAAT,HEXCIJFERS[BT],HEXCIJFERS[BZ])
END;


{>>>>DUMPBLOK<<<<}

PROCEDURE DUMPBLOK(XBLOK : BLOK; VAR APPARAAT : TEXT);

VAR I,J,K : INTEGER;
    CH    : CHAR;

BEGIN
  FOR I:=0 TO 7 DO        { hexdump van 8 regels van 16 karakters }
    BEGIN
      FOR J:=0 TO 15 DO   { Toon hex waarden }
        BEGIN
          SCHRIJF_HEX(APPARAAT,ORD(XBLOK[(I*16)+J]));
          WRITE(APPARAAT,' ')
        END;
      WRITE(APPARAAT,'   |');    { Streep om hex & ASCII te scheiden }
      FOR J:=0 TO 15 DO          { Toon printbare karakters of '.'   }
        BEGIN
          CH:=CHR(XBLOK[(I*16)+J]);
          IF ((ORD(CH)<127) AND (ORD(CH)>31))
          THEN WRITE(APPARAAT,CH) ELSE WRITE(APPARAAT,'.')
        END;
      WRITELN(APPARAAT,'|')
    END;
  FOR I:=0 TO 1 DO WRITELN(APPARAAT,'')
END;  { DUMPBLOK }


{<<<<TOON_HULP>>>>}

PROCEDURE TOON_HULP(HULPNAAM : STRING80);

VAR HULPFILE  : TEXT;
    HULPREGEL : STRING80;
    I         : INTEGER;

BEGIN
  WRITELN;
  ASSIGN(HULPFILE,HULPNAAM);
  {$I-} RESET(HULPFILE); {$I+}
  IF IORESULT = 0 THEN
    FOR I := 1 TO 20 DO
      BEGIN
        READLN(HULPFILE,HULPREGEL);
        WRITELN(HULPREGEL)
      END;
  CLOSE(HULPFILE)
END;


BEGIN
  CLRSCR;                            { Scherm schoon }
  ONTRAFEL_STAART(I,PARMS);          { Ontrafel staart opdrachtregel }
                                     { Alles in hoofdletters ? }
  IF I > 1 THEN PARMS[2] := DWING_KAST(HOOFD,PARMS[2]);
  IF I < 1 THEN                      { Fout - geen parameters }
    BEGIN
      WRITELN('<<Fout!>> Achter HEXDUMP moet een filenaam worden');
      WRITE  ('          opgegeven. Wilt u hulp? (J/N): ');
      IF JA THEN TOON_HULP('DUMPHULP.TXT')
    END
  ELSE
    BEGIN
      ASSIGN(DUMPFILE,PARMS[1]);  { Probeer file te openen }
      {$I-} RESET(DUMPFILE); {$I+}
      IF IORESULT <> 0 THEN       { Fout als file niet te openen }
        BEGIN
          WRITELN('<<Fout!>> File ',PARMS[1],' bestaat niet.');
          WRITE  ('          Wilt u hulp? (J/N): ');
          IF JA THEN TOON_HULP('DUMPHULP.TXT');
        END
      ELSE
        BEGIN                     { Kijken of printparm is opgegeven; }
                                  { en outputapparaat kiezen }
          IF (POS('PRINT',PARMS[2]) = 1) OR (POS('P',PARMS[2]) = 1) THEN
            ASSIGN(APPARAAT,'LST') ELSE ASSIGN(APPARAAT,'CON:');

            { Aanpassing MSX. Niet 'LST:', maar 'LST'. Bovendien moet bij }
            { de MSX de file met REWRITE worden geopend.                  }

          REWRITE(APPARAAT);
          BLOK_TEL := FILESIZE(DUMPFILE);{ Filesize in blokken van 128-bytes }
          IF BLOK_TEL = 0 THEN
            WRITELN('File ',PARMS[1],' is leeg.')
          ELSE
            BEGIN
              BUFFERS := BLOK_TEL DIV 16;  { aantal 16-bloks buffers }
              REMAINS := BLOK_TEL MOD 16;  { aantal blokken in laatste buffer }
              FOR I := 1 TO BUFFERS DO     { Volle 16-bloks buffers dumpen }
                BEGIN
                  BLOCKREAD(DUMPFILE,DISKDATA,16); { Lees 16 diskblokken }
                  FOR J := 0 TO 15 DO
                    DUMPBLOK(DISKDATA[J],APPARAAT)  { Dump ze... }
                END;
              IF REMAINS > 0 THEN  { Als een deels volle buffer overblijft }
                BEGIN              { dat ook dumpen }
                  BLOCKREAD(DUMPFILE,DISKDATA,REMAINS); { Lees laatste buffer }
                  FOR I := 0 TO REMAINS-1 DO
                    DUMPBLOK(DISKDATA[I],APPARAAT)       { Dump hem }
                END
            END;
          CLOSE(DUMPFILE);
          CLOSE(APPARAAT)   { Aanpassing MSX: zorgen dat alles wordt geprint }
        END
    END
END.
