{-----------------------------}
{           LISTMAN           }
{     door Jeff Duntemann     }
{                             }
{  Demoprogramma lijstbeheer  }
{                             }
{ Turbo Pascal V2.0           }
{ Laatste verbetering 2/21/85 }
{-----------------------------}

PROGRAM LISTMAN;

TYPE STRING30 = STRING[30];       { Gebruik van afgeleide stringtypen  }
     STRING7  = STRING[7];        { maakt het type NAPREC kleiner }
     STRING3  = STRING[3];

     NAPPTR = ^NAPREC;
     NAPREC = RECORD
                NAAM      : STRING30;
                ADRES     : STRING30;
                PLAATS    : STRING30;
                PROV      : STRING3;
                PCODE     : STRING7;
                VOLGENDE  : NAPPTR      { Wijst naar volgende NAPREC }
              END;                      { in een lineaire lijst      }

     NAPFILE = FILE OF NAPREC;


VAR CH       : CHAR;
    WORTEL   : NAPPTR;
    STOP     : BOOLEAN;



PROCEDURE WIS_REGELS(EERSTE,LAATSTE : INTEGER);

VAR I : INTEGER;

BEGIN
  FOR I := EERSTE TO LAATSTE DO
    BEGIN
      GOTOXY(1,I);
      CLREOL
    END
END;


FUNCTION JA : BOOLEAN;

VAR CH : CHAR;

BEGIN
  READ(KBD,CH);  { Ongebufferd, dus zonder CR }
  IF CH IN ['J','j'] THEN JA := TRUE ELSE JA := FALSE
END;


PROCEDURE TOON_RECORD(WERKREC : NAPREC);

VAR I : INTEGER;

BEGIN
  WIS_REGELS(17,22);  { Clear away anything in that spot before }
  GOTOXY(1,17);
  WITH WERKREC DO
    BEGIN
      WRITELN('>>Naam:     ',NAAM);
      WRITELN('>>Adres:    ',ADRES);
      WRITELN('>>Plaats:   ',PLAATS);
      WRITELN('>>Prov:     ',PROV);
      WRITELN('>>Pcode:    ',PCODE)
    END
END;


PROCEDURE CHECK_RUIMTE;

VAR RUIMTE      : INTEGER;
    BYTE_RUIMTE : REAL;
    REC_RUIMTE  : REAL;

BEGIN
  RUIMTE := MEMAVAIL;   { MEMAVAIL is negatief als ruimte groter  }
                        { is dan 32,767.  Converteer als waarde negatief is }
                        { (naar real) door er 65536 bij op te tellen }
  IF RUIMTE < 0 THEN BYTE_RUIMTE := 65536.0 + RUIMTE ELSE BYTE_RUIMTE := RUIMTE;

{ BYTE_RUIMTE := BYTE_RUIMTE * 16; } { Verwijder deze regel bij Z80-versie! }
                                     { MEMAVAIL levert bij 8086 het aantal  }
                                     { blokken van 16 bytes, geen bytes!!   }

  REC_RUIMTE := BYTE_RUIMTE / SIZEOF(NAPREC);
  WIS_REGELS(2,3);
  WRITELN('>>Er is nog ruimte voor ',REC_RUIMTE:6:0,' records in de lijst.');
END;


PROCEDURE WEG_LIJST(VAR WORTEL : NAPPTR);

VAR HOUDER : NAPPTR;

BEGIN
  GOTOXY(25,10); WRITE('>>Weet u het zeker? (J/N): ');
  IF JA THEN
    IF WORTEL <> NIL THEN
      REPEAT
        HOUDER := WORTEL^.VOLGENDE;{ Pak het VOLGENDE record..}
        DISPOSE(WORTEL);           { ...en vernietig daarna het EERSTE... }
        WORTEL := HOUDER           { ...maak daarna het tweede het eerste }
      UNTIL WORTEL = NIL;
  WIS_REGELS(10,10);
  CHECK_RUIMTE
END;


PROCEDURE VOEG_RECORDS_TOE(VAR WORTEL : NAPPTR);

VAR I       : INTEGER;
    MAG_WEG : BOOLEAN;
    WERKREC : NAPREC;
    VORIGE  : NAPPTR;
    HUIDIGE : NAPPTR;

BEGIN
  GOTOXY(28,7); WRITE('<<Records toevoegen>>');
  REPEAT               { Tot antwoord op vraag Nog een? Nee is.. }
    WIS_REGELS(24,24);
    FILLCHAR(WERKREC,SIZEOF(WERKREC),CHR(0));  { Record vol nullen }
    WIS_REGELS(9,15);
    GOTOXY(1,9);
    WITH WERKREC DO          { Goede gegevens in record  }
      BEGIN
        WRITE('>>Naam:     '); READLN(NAAM);
        WRITE('>>Adres:    '); READLN(ADRES);
        WRITE('>>Plaats:   '); READLN(PLAATS);
        WRITE('>>Prov:     '); READLN(PROV);
        WRITE('>>Pcode:    '); READLN(PCODE)
      END;
    MAG_WEG := FALSE;
                             { Door lijst lopen op zoek naar duplicaat: }

    IF WORTEL = NIL THEN { Als lijst leeg is WORTEL naar nieuwe laten wijzen }
      BEGIN
        NEW(WORTEL);
        WERKREC.VOLGENDE := NIL;  { Kijken of lijst wordt afgesloten met NIL }
        WORTEL^ := WERKREC;
      END
    ELSE                          { ...als er al iets in de lijst zit   }
      BEGIN
        HUIDIGE := WORTEL;        { Begin lijst bij wortel te doorlopen }
        REPEAT
          IF HUIDIGE^.NAAM = WERKREC.NAAM THEN { Als duplicaat gevonden }
            BEGIN
              TOON_RECORD(HUIDIGE^);
              GOTOXY(1,15);
              WRITE
('>>In record hieronder staat dezelfde naam als hierboven.  Nieuwe weg? (J/N): ');
              IF JA THEN MAG_WEG := TRUE ELSE MAG_WEG := FALSE;
              WIS_REGELS(15,22)
            END;
          VORIGE := HUIDIGE;
          HUIDIGE := HUIDIGE^.VOLGENDE
        UNTIL (HUIDIGE = NIL) OR MAG_WEG OR (HUIDIGE^.NAAM > WERKREC.NAAM);

        IF NOT MAG_WEG THEN              { Voeg WERKREC toe aan lijst  }
          IF WORTEL^.NAAM > WERKREC.NAAM THEN  { Nieuw eerste element! }
            BEGIN
              NEW(WORTEL);                 { Cre	er nieuw dynamisch NAPREC  }
              WERKREC.VOLGENDE := VORIGE;  { dat wijst naar oude eerste}
              WORTEL^ := WERKREC         { Nieuwe eerste wijst naar WERKREC }
            END
          ELSE
            BEGIN
              NEW(VORIGE^.VOLGENDE);       { Cre	er nieu dynamisch NAPREC, }
              WERKREC.VOLGENDE := HUIDIGE; { VOLGENDE hiervan naar HUIDIGE }
              VORIGE^.VOLGENDE^ := WERKREC;{ laten wijzen, WERKREC erin    }
              CHECK_RUIMTE                 { Ruimte in heap laten zien     }
            END;
      END;
    GOTOXY(1,24); WRITE('>>Nog een record toevoegen? (J/N): ');
  UNTIL NOT JA;
END;


PROCEDURE LAAD_LIJST(VAR WORTEL : NAPPTR);

VAR WERKNAAM : STRING30;
    WERKFILE : NAPFILE;
    HUIDIGE  : NAPPTR;
    I        : INTEGER;
    OK       : BOOLEAN;

BEGIN
  STOP := FALSE;
  REPEAT
    WIS_REGELS(10,10);
    WRITE('>>Type de naam van het te laden file, gevolgd door (CR): ');
    READLN(WERKNAAM);
    IF LENGTH(WERKNAAM) = 0 THEN   { Hit (CR) only to abort LOAD }
      BEGIN
        WIS_REGELS(10,12);
        STOP := TRUE
      END
    ELSE
      BEGIN
        ASSIGN(WERKFILE,WERKNAAM);
        {$I-} RESET(WERKFILE); {$I+}
        IF IORESULT <> 0 THEN          { 0 = OK; 255 = File Not Found }
          BEGIN
            GOTOXY(1,12);
            WRITE('>>Die file bestaat niet. Geef een andere op.');
            OK := FALSE
          END
        ELSE OK := TRUE                { OK betekent File Is Open }
      END
    UNTIL OK OR STOP;
  IF NOT STOP THEN
    BEGIN
      WIS_REGELS(10,12);
      HUIDIGE := WORTEL;
      IF WORTEL = NIL THEN               { Als lijst op dit moment leeg is }
        BEGIN
          NEW(WORTEL);                   { Eerste record in WORTEL^ }
          READ(WERKFILE,WORTEL^);
          HUIDIGE := WORTEL
        END                         { Als lijst niet leeg, dan eind zoeken: }
      ELSE WHILE HUIDIGE^.VOLGENDE <> NIL DO HUIDIGE := HUIDIGE^.VOLGENDE;
      IF WORTEL^.VOLGENDE <> NIL THEN    { Als meer dan 1 record in file }
      REPEAT
        NEW(HUIDIGE^.VOLGENDE);          { Lees record en voeg dit toe }
        HUIDIGE := HUIDIGE^.VOLGENDE;    { tot het veld VOLGENDE van een  }
        READ(WERKFILE,HUIDIGE^)          { record NIL blijkt te zijn  }
      UNTIL HUIDIGE^.VOLGENDE = NIL;
      CHECK_RUIMTE;
      CLOSE(WERKFILE)
    END
END;


PROCEDURE BEKIJK_LIJST(WORTEL : NAPPTR);

VAR I        : INTEGER;
    WERKFILE : NAPFILE;
    HUIDIGE  : NAPPTR;

BEGIN
  IF WORTEL = NIL THEN                 { Er staat niets in de lijst }
    BEGIN
      GOTOXY(28,18);
      WRITELN('<<De lijst is leeg!>>');
      GOTOXY(25,20);
      WRITE('>>Druk op (CR) voor vervolg: ');
      READLN
    END
  ELSE
    BEGIN
      GOTOXY(29,7); WRITE('<<Records bekijken>>');
      HUIDIGE := WORTEL;
      WHILE HUIDIGE <> NIL DO { Lijst doorlopen, afdrukken tot NIL gevonden is}
        BEGIN
          TOON_RECORD(HUIDIGE^);
          GOTOXY(1,23);
          WRITE('>>Druk op (CR) om het volgende record te bekijken: ');
          READLN;
          HUIDIGE := HUIDIGE^.VOLGENDE
        END;
      WIS_REGELS(19,22)
    END
END;


PROCEDURE SAVE_LIJST(WORTEL : NAPPTR);

VAR WERKNAAM : STRING30;
    WERKFILE : NAPFILE;
    HUIDIGE  : NAPPTR;
    I        : INTEGER;

BEGIN
  GOTOXY(1,10);
  WRITE('>>Naam van de file waarin de lijst moet komen, gevold door (CR): ');
  READLN(WERKNAAM);
  ASSIGN(WERKFILE,WERKNAAM);   { Open de file om in te schrijven }
  REWRITE(WERKFILE);
  HUIDIGE := WORTEL;
  WHILE HUIDIGE <> NIL DO      { Doorloop lijst en schrijf records }
    BEGIN
      WRITE(WERKFILE,HUIDIGE^);
      HUIDIGE := HUIDIGE^.VOLGENDE
    END;
  CLOSE(WERKFILE)
END;



BEGIN       { LISTMAN Hoofdprogramma }
  CLRSCR;
  GOTOXY(25,1); WRITE('<<Lineaire lijstenmaker>>');
  CHECK_RUIMTE;
  GOTOXY(17,8);  WRITE('--------------------------------------------');
  WORTEL := NIL; STOP := FALSE;
  REPEAT       {FOO}
    WIS_REGELS(5,7);
    WIS_REGELS(9,24);
    GOTOXY(1,5);
    WRITE
    ('>>[L]aden, [O]pslaan, [W]issen; Record [T]oevoegen, [B]ekijken of [S]toppen: ');
    READ(kbd,CH);         { Wacht op opdracht, ongebufferd, dus zonder CR }
    WRITE(CH);
    CASE CH OF
     'B','b' : BEKIJK_LIJST(WORTEL);
     'L','l' : LAAD_LIJST(WORTEL);
     'O','o' : SAVE_LIJST(WORTEL);
     'S','s' : STOP := TRUE;
     'T','t' : VOEG_RECORDS_TOE(WORTEL);
     'W','w' : WEG_LIJST(WORTEL)
      ELSE {LEEG}
    END; { CASE }
  UNTIL STOP;
  GOTOXY(1,24)
END.
