{-----------------------------}
{            SCHERM           }
{        Jeff Duntemann       }
{                             }
{ Scherminvoer demoprogramma  }
{                             }
{      Turbo Pascal V2.0      }
{ Laatste verbetering 3/9/85  }
{-----------------------------}


PROGRAM SCHERM;

{$V-}  { Lengte van string VAR parameters mag afwijken.  Zie 23.4 }

CONST CAPSLOCK        = TRUE;
      GEEN_CAPSLOCK   = FALSE;
      NUMERIEK        = TRUE;
      NIET_NUMERIEK   = FALSE;

TYPE STRING80 = STRING[80];
     STRING30 = STRING[30];
     STRING7  = STRING[7];
     STRING4  = STRING[4];
     STRING3  = STRING[3];

     NAPREC   = RECORD
                  NAAM      : STRING30;
                  ADRES     : STRING30;
                  PLAATS    : STRING30;
                  PROVINCIE : STRING3;
                  POSTCODE  : STRING7
                END;

     GRAFREC = RECORD        { Om vakken te tekenen }
                 LB_HOEK,
                 RB_HOEK,
                 LO_HOEK,
                 RO_HOEK,
                 H_BALK,
                 V_BALK,
                 KRUISING,
                 T_OMLAAG,
                 T_OMHOOG,
                 T_RECHTS,
                 T_LINKS     : STRING[4]
               END;


VAR  CH             : CHAR;
     DIT_RECORD     : NAPREC;
     GRAFKARS       : GRAFREC;
     EDIT           : BOOLEAN;
     STOP           : BOOLEAN;
     ESCAPE         : BOOLEAN;
     BREEDTE,HOOGTE : INTEGER;
     I,J            : INTEGER;
     R              : REAL;


PROCEDURE BLIEP;

BEGIN
  WRITE(CHR(7))
END;


PROCEDURE MAAK_VAK(X,Y,BREEDTE,HOOGTE : INTEGER;
                      GRAFKARS        : GRAFREC);

VAR I,J : INTEGER;

BEGIN
  IF X < 0 THEN X := (80-BREEDTE) DIV 2;    { Negatieve X centreert vak }
  WITH GRAFKARS DO
    BEGIN                                   { Teken bovenste lijn }
      GOTOXY(X,Y); WRITE(LB_HOEK);
      FOR I := 3 TO BREEDTE DO WRITE(H_BALK);
      WRITE(RB_HOEK);
                                            { Teken onderste lijn }
      GOTOXY(X,(Y+HOOGTE)-1); WRITE(LO_HOEK);
      FOR I := 3 TO BREEDTE DO WRITE(H_BALK);
      WRITE(RO_HOEK);
                                            { Teken zijlijnen }
      FOR I := 1 TO HOOGTE-2 DO
        BEGIN
          GOTOXY(X,Y+I); WRITE(V_BALK);
          GOTOXY((X+BREEDTE)-1,Y+I); WRITE(V_BALK)
        END
    END
END;


{$I TOETSTAT.MSX }     { Zie sectie 20.6 }

{$I HAALSTRI.SRC }     { Zie sectie 15.2 }

{$I GRAFKARS.MSX }

{$I JA.SRC       }

{$I CURSOFF.SRC  }

{$I CURSON.SRC   }



PROCEDURE HAAL_SCHERM(VAR SCHERM_DATA : NAPREC;
                          EDIT        : BOOLEAN;
                      VAR ESCAPE      : BOOLEAN);

BEGIN
  MAAK_VAK(1,1,79,20,GRAFKARS);         { Teken vak op scherm            }
  IF NOT EDIT THEN WITH SCHERM_DATA DO  { Niet editen, dan scherm schoon }
    BEGIN
      NAAM := ''; ADRES := ''; PLAATS := ''; PROVINCIE := ''; POSTCODE := ''
    END;
  GOTOXY(23,2);
  WRITELN('<< Invoerscherm Naam / Adres >>');
  WITH SCHERM_DATA DO
    BEGIN                        { Eerst veld-vakken tekenen: }
      GOTOXY(5,7);
      WRITE('>>         Naam:    |..............................|');
      GOTOXY(5,9);
      WRITE('>>         Adres:   |..............................|');
      GOTOXY(5,11);
      WRITE('>>         Plaats:  |..............................|');
      GOTOXY(5,13);
      WRITE('>>         Prov.    |...|');
      GOTOXY(5,15);
      WRITE('>>         Postcode |.......| ');
      IF EDIT THEN WITH SCHERM_DATA DO  { Als Edit, dan huidige waarden tonen }
        BEGIN
          GOTOXY(26,7);  WRITE(NAAM);
          GOTOXY(26,9);  WRITE(ADRES);
          GOTOXY(26,11); WRITE(PLAATS);
          GOTOXY(26,13); WRITE(PROVINCIE);
          GOTOXY(26,15); WRITE(POSTCODE)
        END;                            { Nu veld-gegevens invoeren/veranderen }
      HAALSTRING(25,7,NAAM,30,GEEN_CAPSLOCK,NIET_NUMERIEK,FALSE,R,I,J,ESCAPE);
      IF NOT ESCAPE THEN
        HAALSTRING(25,9,ADRES,30,GEEN_CAPSLOCK,NIET_NUMERIEK,FALSE,R,I,J,ESCAPE);
      IF NOT ESCAPE THEN
        HAALSTRING(25,11,PLAATS,30,GEEN_CAPSLOCK,NIET_NUMERIEK,FALSE,R,I,J,ESCAPE);
      IF NOT ESCAPE THEN
        HAALSTRING(25,13,PROVINCIE,3,CAPSLOCK,NIET_NUMERIEK,FALSE,R,I,J,ESCAPE);
      IF NOT ESCAPE THEN
        HAALSTRING(25,15,POSTCODE,7,CAPSLOCK,NIET_NUMERIEK,FALSE,R,I,J,ESCAPE);
    END
END;


BEGIN        { SCHERM Hoofdprogramma }
  DEFINIEER_KARS(GRAFKARS);        { Laad karakters om vak te tekenen }
  EDIT := FALSE;
  REPEAT
    CURSOR_OFF;
    CLRSCR;
    HAAL_SCHERM(DIT_RECORD,EDIT,ESCAPE);     { Gegevens invoeren/ veranderen}
    IF ESCAPE THEN STOP := TRUE ELSE         { Stop als op ESC gedrukt }
      BEGIN                                  { Anders gegevens samenvatten }
        STOP := FALSE;                       { en goedkeuring vragen }
        GOTOXY(1,22);
        WRITE('>>Samengevat: ');
        WITH DIT_RECORD DO
          BEGIN
            WRITE(NAAM,'/',ADRES,'/',POSTCODE,'/',PLAATS);
            CURSOR_ON;
            GOTOXY(1,23); WRITE('>>In orde? (J/N): ');
            IF JA THEN EDIT := FALSE ELSE EDIT := TRUE
          END
      END
  UNTIL STOP;
  CURSOR_ON;
  GOTOXY(1,22)
END.
