
{--------------------------------------------------------------}
{                          WORDSTAT                            }
{                                                              }
{       Telt woorden en woordlengtes in een tekstfile          }
{                                                              }
{                              Jeff Duntemann                  }
{                              Turbo Pascal V2.0/3.0           }
{                              Laatste verbetering 10/26/84    }
{                                                              }
{                 (c) 1984 Jeff Duntemann                      }
{                 ALL RIGHTS RESERVED                          }
{--------------------------------------------------------------}


PROGRAM WORDSTAT;


{ Let op de printeraanpassing voor de MSX-versie: zie de bijlage }
{ van het boek. De file 'LST' moet worden gesloten om ervoor te  }
{ zorgen dat de printer alles afdrukt.                           }



CONST PRINT_BR    = 68;


TYPE  ARRAY_40    = ARRAY[0..40] OF INTEGER;
      STRING80    = STRING[80];

VAR   I,J,K        : INTEGER;
      SCHAAL       : REAL;
      CH           : CHAR;
      OPEN		       : BOOLEAN;
      TESTFILE     : TEXT;
      FILENAAM     : STRING80;
      TELLERS      : ARRAY_40;
      REGEL        : STRING80;
      WOORD        : STRING80;
      WOORD_LENGTE : INTEGER;
      REGELTEL     : INTEGER;
      STAART       : STRING80 ABSOLUTE $80;           { CP/M-80/MSX-DOS }
     {STAART       : STRING80 ABSOLUTE CSEG : $80;}   { PC/MS DOS }
      PRINTER      : TEXT;    { Aanpassing MSX-versie }

PROCEDURE WEG_WIT(VAR EEN_STRING : STRING80);

VAR BLANCO_RUIMTE : SET OF CHAR;

BEGIN
  BLANCO_RUIMTE := [CHR(8),CHR(9),CHR(10),CHR(12),CHR(13),' '];
  REPEAT
    IF LENGTH(EEN_STRING) > 0 THEN
      IF EEN_STRING[1] IN BLANCO_RUIMTE THEN DELETE(EEN_STRING,1,1);
  UNTIL (NOT (EEN_STRING[1] IN BLANCO_RUIMTE)) OR (LENGTH(EEN_STRING)<=0)
END;



PROCEDURE OPENER(    FILENAAM : STRING80;
                 VAR TFILE    : TEXT;
                 VAR OPENVLAG : BOOLEAN);

VAR I : INTEGER;

BEGIN
  ASSIGN(TFILE,FILENAAM);       { Koppel logisch aan fysiek file   }
  RESET(TFILE);                 { Open file om te lezen            }
  I := IORESULT;                { I <> 0 = File niet gevonden      }
  IF I = 0 THEN OPENVLAG := TRUE ELSE OPENVLAG := FALSE;
END;  { OPENER }



FUNCTION MAAKSCHAAL(TELLERS : ARRAY_40) : REAL;

VAR I,MAXTELLER : INTEGER;

BEGIN
  MAXTELLER := 0;                           { Initialiseer maxteller      }
  FOR I := 1 TO 40 DO
    IF TELLERS[I] > MAXTELLER THEN MAXTELLER := TELLERS[I];
      IF MAXTELLER > PRINT_BR THEN MAAKSCHAAL := PRINT_BR / MAXTELLER
    ELSE MAAKSCHAAL := 1.0;    { Schaal=1 als maxteller < printer breedte }
END;  { MAAKSCHAAL }



PROCEDURE TEKENAAR(TELLERS : ARRAY_40; SCHAAL : REAL);

VAR I,J : INTEGER;

BEGIN                  { Aanpassingen voor MSX: PRINTER i.p.v. LST }
  WRITELN(SCHAAL);
  FOR I := 1 TO 40 DO
    BEGIN
      WRITE(PRINTER,'[',I:3,']: ');                { print aantal }
      FOR J:=1 TO ROUND(TELLERS[I] * SCHAAL) DO WRITE(PRINTER,'*');
      WRITELN(PRINTER,'')                          { <CR> aan eind van *-en}
    END
END;


BEGIN   { WORDSTAT Hoofdprogramma }

  FILENAAM := paramstr(1);          { Eerst filenaam uit opdrachtregel lezen,}
  WEG_WIT(FILENAAM);                { daarna pas file openen!                }
  FOR I:=0 TO 40 DO TELLERS[I]:=0;  { Initialiseer tellers }
  REGELTEL := 0;
  OPENER(FILENAAM,TESTFILE,OPEN);  { Poging input file te openen }
  IF NOT OPEN THEN                 { Als dat niet likt...        }
    BEGIN
      WRITELN('>>>Input file ',FILENAAM,' bestaat niet of niet in orde.');
      WRITELN('   Kijk eerst wat er met dit file aan de hand is.');
    END
  ELSE                            { Als het file er is aan de slag!    }
    BEGIN
      WHILE NOT EOF(TESTFILE) DO  { Zolang er iets in het file zit   }
        BEGIN
          READLN(TESTFILE,REGEL);      { lees een regel }
          REGELTEL := REGELTEL + 1;    { Tel regel      }
          WHILE LENGTH(REGEL) > 0 DO   { Zolang er woorden in regel zijn }
            BEGIN
              WEG_WIT(REGEL);          { Verwijder blanco ruimte aan begin }
              IF POS(' ',REGEL) > 0 THEN
                WOORD := COPY(REGEL,1,POS(' ',REGEL)) ELSE WOORD := REGEL;
              TELLERS[0] := TELLERS[0] + 1;    { Tel woord }
              WOORD_LENGTE := LENGTH(WOORD);
              IF WOORD_LENGTE > 40 THEN WOORD_LENGTE := 40;
              J := TELLERS[WOORD_LENGTE];     { Neem teller voor deze lengte }
              J := J + 1;                     { Verhoog met 1...             }
              TELLERS[WOORD_LENGTE] := J;     { ...en zet hem terug.         }
              DELETE(REGEL,1,LENGTH(WOORD));  { Verwijder woord uit regel    }
            END
        END;
      CLOSE(TESTFILE);                        { Sluit het input file         }
      SCHAAL := MAAKSCHAAL(TELLERS);          { Tellers op schaal brengen }
      ASSIGN(PRINTER,'LST');                  { Aanpassing MSX            }
      REWRITE(PRINTER);                       { idem                      }
      WRITELN(PRINTER,                        { idem, PRINTER i.pv. LST   }
      '>>Tekstfile ',FILENAAM,
      ' bevat ',TELLERS[0],
      ' woorden in ',REGELTEL,' regels.');
      WRITELN(LST,
      '  Histogram van de woordlengte:');
      TEKENAAR(TELLERS,SCHAAL);               { Print histogrammen op schaal  }
      WRITELN(PRINTER,CHR(12));               { Pagina uit printer (stuur FF) }
      CLOSE(PRINTER)                          { Aanpassing MSX                }
    END
END.